Open CASCADE Technology: BRepFeat_MakeCylindricalHole Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
BRepFeat_MakeCylindricalHole Class Reference

Provides a tool to make cylindrical holes on a shape. More...

`#include <BRepFeat_MakeCylindricalHole.hxx>`

Inheritance diagram for BRepFeat_MakeCylindricalHole:
[legend]

## Public Member Functions
| BRepFeat_MakeCylindricalHole ()
| Empty constructor. More...
void | Init (const gp_Ax1 &Axis)
| Sets the axis of the hole(s). More...
void | Init (const TopoDS_Shape &S, const gp_Ax1 &Axis)
| Sets the shape and axis on which hole(s) will be performed. More...
void | Perform (const Standard_Real Radius)
| Performs every holes of radius <Radius>. This command has the same effect as a cut operation with an infinite cylinder defined by the given axis and <Radius>. More...
void | Perform (const Standard_Real Radius, const Standard_Real PFrom, const Standard_Real PTo, const Standard_Boolean WithControl=Standard_True)
| Performs evry hole of radius <Radius> located between PFrom and PTo on the given axis. If <WithControl> is set to Standard_False no control are done on the resulting shape after the operation is performed. More...
void | PerformThruNext (const Standard_Real Radius, const Standard_Boolean WithControl=Standard_True)
| Performs the first hole of radius <Radius>, in the direction of the defined axis. First hole signify first encountered after the origin of the axis. If <WithControl> is set to Standard_False no control are done on the resulting shape after the operation is performed. More...
void | PerformUntilEnd (const Standard_Real Radius, const Standard_Boolean WithControl=Standard_True)
| Performs evry holes of radius <Radius> located after the origin of the given axis. If <WithControl> is set to Standard_False no control are done on the resulting shape after the operation is performed. More...
void | PerformBlind (const Standard_Real Radius, const Standard_Real Length, const Standard_Boolean WithControl=Standard_True)
| Performs a blind hole of radius <Radius> and length <Length>. The length is measured from the origin of the given axis. If <WithControl> is set to Standard_False no control are done after the operation is performed. More...
BRepFeat_Status | Status () const
| Returns the status after a hole is performed. More...
void | Build ()
| Builds the resulting shape (redefined from MakeShape). Invalidates the given parts of tools if any, and performs the result of the local operation. More...
Public Member Functions inherited from BRepFeat_Builder
| BRepFeat_Builder ()
virtual | ~BRepFeat_Builder ()
virtual void | Clear ()
| Clears internal fields and arguments. More...
void | Init (const TopoDS_Shape &theShape)
| Initialyzes the object of local boolean operation. More...
void | Init (const TopoDS_Shape &theShape, const TopoDS_Shape &theTool)
| Initialyzes the arguments of local boolean operation. More...
void | SetOperation (const Standard_Integer theFuse)
| Sets the operation of local boolean operation. If theFuse = 0 than the operation is CUT, otherwise FUSE. More...
void | SetOperation (const Standard_Integer theFuse, const Standard_Boolean theFlag)
| Sets the operation of local boolean operation. If theFlag = TRUE it means that no selection of parts of the tool is needed, t.e. no second part. In that case if theFuse = 0 than operation is COMMON, otherwise CUT21. If theFlag = FALSE SetOperation(theFuse) function is called. More...
void | PartsOfTool (TopTools_ListOfShape &theLT)
| Collects parts of the tool. More...
void | KeepParts (const TopTools_ListOfShape &theIm)
| Initialyzes parts of the tool for second step of algorithm. Collects shapes and all sub-shapes into myShapes map. More...
void | KeepPart (const TopoDS_Shape &theS)
| Adds shape theS and all its sub-shapes into myShapes map. More...
void | PerformResult ()
| Main function to build the result of the local operation required. More...
void | RebuildFaces ()
| Rebuilds faces in accordance with the kept parts of the tool. More...
void | RebuildEdge (const TopoDS_Shape &theE, const TopoDS_Face &theF, const BOPCol_MapOfShape &theME, BOPCol_ListOfShape &aLEIm)
| Rebuilds edges in accordance with the kept parts of the tool. More...
void | CheckSolidImages ()
| Collects the images of the object, that contains in the images of the tool. More...
void | FillRemoved ()
| Collects the removed parts of the tool into myRemoved map. More...
void | FillRemoved (const TopoDS_Shape &theS, BOPCol_MapOfShape &theM)
| Adds the shape S and its sub-shapes into myRemoved map. More...
Public Member Functions inherited from BOPAlgo_BOP
| BOPAlgo_BOP ()
| Empty constructor. More...
virtual | ~BOPAlgo_BOP ()
| BOPAlgo_BOP (const BOPCol_BaseAllocator &theAllocator)
virtual void | AddTool (const TopoDS_Shape &theShape)
| Adds Tool argument of the operation. More...
virtual void | SetTools (const TopTools_ListOfShape &theShapes)
virtual void | SetTools (const BOPCol_ListOfShape &theShapes)
void | SetOperation (const BOPAlgo_Operation theOperation)
BOPAlgo_Operation | Operation () const
virtual void | Perform ()
Public Member Functions inherited from BOPAlgo_Builder
| BOPAlgo_Builder ()
virtual | ~BOPAlgo_Builder ()
| BOPAlgo_Builder (const BOPCol_BaseAllocator &theAllocator)
BOPAlgo_PPaveFiller | PPaveFiller ()
BOPDS_PDS | PDS ()
virtual void | AddArgument (const TopoDS_Shape &theShape)
void | SetArguments (const TopTools_ListOfShape &theLS)
virtual void | SetArguments (const BOPCol_ListOfShape &theLS)
const BOPCol_ListOfShape & | Arguments () const
virtual void | PerformWithFiller (const BOPAlgo_PaveFiller &theFiller)
virtual const TopTools_ListOfShape & | Generated (const TopoDS_Shape &theS)
| Returns the list of shapes generated from the shape theS. More...
virtual const TopTools_ListOfShape & | Modified (const TopoDS_Shape &theS)
| Returns the list of shapes modified from the shape theS. More...
virtual Standard_Boolean | IsDeleted (const TopoDS_Shape &theS)
| Returns true if the shape theS has been deleted. More...
const BOPCol_DataMapOfShapeListOfShape & | Images () const
Standard_Boolean | IsInterferred (const TopoDS_Shape &theS) const
const BOPCol_DataMapOfShapeShape & | Origins () const
| Returns myOrigins. More...
const BOPCol_DataMapOfShapeShape & | ShapesSD () const
| Returns myShapesSD. More...
const BOPCol_DataMapOfShapeListOfShape & | Splits () const
| Returns mySplits. More...
void | SetFuzzyValue (const Standard_Real theFuzz)
| Sets the additional tolerance. More...
Standard_Real | FuzzyValue () const
| Returns the additional tolerance. More...
Public Member Functions inherited from BOPAlgo_BuilderShape
const TopoDS_Shape & | Shape () const
| Returns the result of algorithm. More...
Standard_Boolean | HasDeleted () const
| Returns true if the at least one shape(or subshape) of arguments has been deleted. More...
Standard_Boolean | HasGenerated () const
| Returns true if the at least one shape(or subshape) of arguments has generated shapes. More...
Standard_Boolean | HasModified () const
| Returns true if the at least one shape(or subshape) of arguments has modified shapes. More...
const BOPCol_IndexedDataMapOfShapeListOfShape & | ImagesResult () const
Public Member Functions inherited from BOPAlgo_Algo
Standard_Integer | ErrorStatus () const
Standard_Integer | WarningStatus () const
const BOPCol_BaseAllocator & | Allocator () const
void | SetRunParallel (const Standard_Boolean theFlag)
| Set the flag of parallel processing if <theFlag> is true the parallel processing is switched on if <theFlag> is false the parallel processing is switched off. More...
Standard_Boolean | RunParallel () const
| Returns the flag of parallel processing. More...
void | SetProgressIndicator (const Handle< Message_ProgressIndicator > &theObj)
| Set the Progress Indicator object. More...

## Additional Inherited Members
Static Public Member Functions inherited from BOPAlgo_Algo
static Standard_Boolean | GetParallelMode ()
static void | SetParallelMode (const Standard_Boolean theNewMode)
Protected Member Functions inherited from BRepFeat_Builder
virtual void | Prepare ()
| Prepares builder of local operation. More...
virtual void | FillIn3DParts (BOPCol_DataMapOfShapeListOfShape &theInParts, BOPCol_DataMapOfShapeShape &theDraftSolids, const BOPCol_BaseAllocator &theAllocator)
| Function is redefined to avoid the usage of removed faces. More...
Protected Member Functions inherited from BOPAlgo_BOP
virtual void | CheckData ()
virtual void | PerformInternal1 (const BOPAlgo_PaveFiller &thePF)
| Performs calculations using prepared Filler object <thePF> More...
virtual void | BuildResult (const TopAbs_ShapeEnum theType)
void | BuildShape ()
void | BuildRC ()
void | BuildSolid ()
Standard_Boolean | IsBoundSplits (const TopoDS_Shape &theS, BOPCol_IndexedDataMapOfShapeListOfShape &theMEF)
Protected Member Functions inherited from BOPAlgo_Builder
virtual void | PrepareHistory ()
| Prepare information for history support. More...
virtual void | PerformInternal (const BOPAlgo_PaveFiller &thePF)
void | FillImagesVertices ()
void | FillImagesEdges ()
void | FillImagesContainers (const TopAbs_ShapeEnum theType)
void | FillImagesCompounds ()
void | FillImagesContainer (const TopoDS_Shape &theS, const TopAbs_ShapeEnum theType)
void | FillImagesCompound (const TopoDS_Shape &theS, BOPCol_MapOfShape &theMF)
void | FillImagesFaces ()
virtual void | BuildSplitFaces ()
void | FillSameDomainFaces ()
void | FillImagesFaces1 ()
void | FillImagesSolids ()
void | BuildDraftSolid (const TopoDS_Shape &theSolid, TopoDS_Shape &theDraftSolid, BOPCol_ListOfShape &theLIF)
void | BuildSplitSolids (BOPCol_DataMapOfShapeListOfShape &theInParts, BOPCol_DataMapOfShapeShape &theDraftSolids, const BOPCol_BaseAllocator &theAllocator)
void | FillInternalShapes ()
virtual void | PostTreat ()
Protected Member Functions inherited from BOPAlgo_BuilderShape
| BOPAlgo_BuilderShape ()
virtual | ~BOPAlgo_BuilderShape ()
| BOPAlgo_BuilderShape (const BOPCol_BaseAllocator &theAllocator)
Protected Member Functions inherited from BOPAlgo_Algo
| BOPAlgo_Algo ()
virtual | ~BOPAlgo_Algo ()
| BOPAlgo_Algo (const BOPCol_BaseAllocator &theAllocator)
virtual void | CheckResult ()
void | UserBreak () const
| Breaks the execution if the break signal is indicated by myProgressIndicator. More...
Protected Attributes inherited from BRepFeat_Builder
BOPCol_MapOfShape | myShapes
BOPCol_MapOfShape | myRemoved
Standard_Integer | myFuse
Protected Attributes inherited from BOPAlgo_BOP
BOPAlgo_Operation | myOperation
Standard_Integer | myDims [2]
TopoDS_Shape | myRC
BOPCol_ListOfShape | myTools
BOPCol_MapOfShape | myMapTools
Protected Attributes inherited from BOPAlgo_Builder
BOPCol_ListOfShape | myArguments
BOPCol_MapOfShape | myMapFence
BOPAlgo_PPaveFiller | myPaveFiller
BOPDS_PDS | myDS
Handle< IntTools_Context > | myContext
Standard_Integer | myEntryPoint
BOPCol_DataMapOfShapeListOfShape | myImages
BOPCol_DataMapOfShapeShape | myShapesSD
BOPCol_DataMapOfShapeListOfShape | mySplits
BOPCol_DataMapOfShapeShape | myOrigins
Standard_Real | myFuzzyValue
Protected Attributes inherited from BOPAlgo_BuilderShape
TopoDS_Shape | myShape
TopTools_ListOfShape | myHistShapes
BOPCol_MapOfShape | myMapShape
Standard_Boolean | myHasDeleted
Standard_Boolean | myHasGenerated
Standard_Boolean | myHasModified
BOPCol_IndexedDataMapOfShapeListOfShape | myImagesResult
Standard_Boolean | myFlagHistory
Protected Attributes inherited from BOPAlgo_Algo
BOPCol_BaseAllocator | myAllocator
Standard_Integer | myErrorStatus
Standard_Integer | myWarningStatus
Standard_Boolean | myRunParallel
Handle< Message_ProgressIndicator > | myProgressIndicator

## Detailed Description

Provides a tool to make cylindrical holes on a shape.

## Constructor & Destructor Documentation

BRepFeat_MakeCylindricalHole::BRepFeat_MakeCylindricalHole | ( |  | ) |

Empty constructor.

## Member Function Documentation

void BRepFeat_MakeCylindricalHole::Build | ( |  | ) |

Builds the resulting shape (redefined from MakeShape). Invalidates the given parts of tools if any, and performs the result of the local operation.

void BRepFeat_MakeCylindricalHole::Init | ( | const gp_Ax1 & | Axis | ) |

Sets the axis of the hole(s).

void BRepFeat_MakeCylindricalHole::Init | ( | const TopoDS_Shape & | S,
|  | const gp_Ax1 & | Axis
| ) |  |

Sets the shape and axis on which hole(s) will be performed.

void BRepFeat_MakeCylindricalHole::Perform | ( | const Standard_Real | Radius | ) |

Performs every holes of radius <Radius>. This command has the same effect as a cut operation with an infinite cylinder defined by the given axis and <Radius>.

void BRepFeat_MakeCylindricalHole::Perform | ( | const Standard_Real | Radius,
|  | const Standard_Real | PFrom,
|  | const Standard_Real | PTo,
|  | const Standard_Boolean | WithControl = `Standard_True`
| ) |  |

Performs evry hole of radius <Radius> located between PFrom and PTo on the given axis. If <WithControl> is set to Standard_False no control are done on the resulting shape after the operation is performed.

void BRepFeat_MakeCylindricalHole::PerformBlind | ( | const Standard_Real | Radius,
|  | const Standard_Real | Length,
|  | const Standard_Boolean | WithControl = `Standard_True`
| ) |  |

Performs a blind hole of radius <Radius> and length <Length>. The length is measured from the origin of the given axis. If <WithControl> is set to Standard_False no control are done after the operation is performed.

void BRepFeat_MakeCylindricalHole::PerformThruNext | ( | const Standard_Real | Radius,
|  | const Standard_Boolean | WithControl = `Standard_True`
| ) |  |

Performs the first hole of radius <Radius>, in the direction of the defined axis. First hole signify first encountered after the origin of the axis. If <WithControl> is set to Standard_False no control are done on the resulting shape after the operation is performed.

void BRepFeat_MakeCylindricalHole::PerformUntilEnd | ( | const Standard_Real | Radius,
|  | const Standard_Boolean | WithControl = `Standard_True`
| ) |  |

Performs evry holes of radius <Radius> located after the origin of the given axis. If <WithControl> is set to Standard_False no control are done on the resulting shape after the operation is performed.

BRepFeat_Status BRepFeat_MakeCylindricalHole::Status | ( |  | ) | const

Returns the status after a hole is performed.

The documentation for this class was generated from the following file:

- BRepFeat_MakeCylindricalHole.hxx